// dllmain.cpp : Defines the entry point for the DLL application.
// https://msdn.microsoft.com/en-us/library/ms185328.aspx?f=255&MSPPError=-2147217396
#include "stdafx.h"
#include <stdio.h>
#include <windows.h>
#include <WinUser.h>
#include <string.h>

TCHAR szPath[MAX_PATH] = {0};
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	// create log file path
	if (!GetModuleFileName(hModule, szPath, MAX_PATH))
	{
		//printf("Cannot get GetModuleFileName (%d)\n", GetLastError());
		//return;
	}
	*(wcsrchr(szPath, '\\') + 1) = 0; wcscat_s(szPath, TEXT("hook_dllInjection.txt")); 
	/* open file */
	FILE *file;
	//fopen_s(&file, "C:\\temp\\hook_dllInjection.txt", "a+");
	_wfopen_s(&file, szPath, TEXT("a+"));
	HWND hWnd = NULL;
	LONG_PTR adrWndProc = NULL;
	long long int offsetZoneData = NULL;
	long long int segmentZoneData = NULL;
	BYTE * lpt_monByte = NULL;

	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		fprintf(file, "DLL attach function called.\n");
		break;
	case DLL_THREAD_ATTACH:
		fprintf(file, "DLL thread attach function called.\n");
		// chercher la fenetre Shell_TrayWdn
		hWnd = FindWindow(TEXT("Shell_TrayWnd"), TEXT(""));
		// lire l'adresse de la windowProc
		adrWndProc = GetWindowLongPtr(hWnd, GWLP_WNDPROC);
		//00007ff6`49ad4030
		fprintf(file, "Adresse WNDPROC : %llp\r\n", adrWndProc);
		// lire la zone de donnes contenant les data de la fentre ( voir SPY++ et "windows Bytes")
		offsetZoneData = GetWindowLongPtr(hWnd, 0);
		//   adresse  : 00007FF649CB6860
		fprintf(file, "OffsetZoneData : %llp\r\n", offsetZoneData);
		// cration du pointeur sur le byte offsetZoneData + 0x2f9
		// 00007ff6`49CB6860 + 2f9 = 7ff649cb6b59
		lpt_monByte = (BYTE *)(offsetZoneData + 0x2f9);
		fprintf(file, "lpt_monByte : %llp\r\n", lpt_monByte);
		fprintf(file, "Avant *lpt_monByte : %x\r\n", *lpt_monByte);
		*lpt_monByte = 0;
		fprintf(file, "Aprs *lpt_monByte : %x\r\n", *lpt_monByte);

		break;
	case DLL_THREAD_DETACH:
		fprintf(file, "DLL thread detach function called.\n");
		break;
	case DLL_PROCESS_DETACH:
		fprintf(file, "DLL detach function called.\n");
		break;
	}

	/* close file */
	fclose(file);

	return TRUE;
}

// http://stackoverflow.com/questions/4352449/pointer-to-a-callback-in-a-dll
extern "C" __declspec(dllexport) LRESULT CALLBACK meconnect(int code, WPARAM wParam, LPARAM lParam) {
//extern "C" __declspec(dllexport) int meconnect(int code, WPARAM wParam, LPARAM lParam) {
	FILE *file;
	//fopen_s(&file, "C:\\temp\\hook_function.txt", "a+");
	//fprintf(file, "Function keyboard_hook called \n");
	//fclose(file);

	LPCWPSTRUCT pt_stMessage = (LPCWPSTRUCT)lParam;
	if (code >= 0 )
	{
		if (pt_stMessage->message == 0x579 && pt_stMessage->wParam == 3)
		{
			//fopen_s(&file, "C:\\temp\\hook_function.txt", "a+");
			_wfopen_s(&file, szPath, TEXT("a+"));
			fprintf(file, "Function hook called avec code=0x%x msg=0x%x wParam=0x%x\n", code, pt_stMessage->message, pt_stMessage->wParam);
			//fprintf(file, "Function keyboard_hook called \n");
			fclose(file);
		}
	}

	return(CallNextHookEx(NULL, code, wParam, lParam));
}